window.onhashchange = function() { window.location.reload() }

var download_url = null

function load_ace(){
  var div = document.getElementById("editor");
	window.editor = ace.edit(div);
  //window.editor.setOptions({minLines: 20, maxLines: Infinity});
  editor.setAutoScrollEditorIntoView(true);

	var ocamlMode = ace.require("ace/mode/ocaml").Mode;
  window.editor.session.setMode(new ocamlMode());

  /*var current_okd = editor.onkeydown;

  var onkeydown = function(e){
     if(e.ctrlKey && e.keyCode == 69){
      console.log(editor.getSelectedText());
     }
  }

  document.addEventListener("keydown", onkeydown, true);*/
  window.editor.setValue(document.getElementById("initial-content").innerText);
};

function new_file(){
  window.editor.setValue("");
  window.output_file.download = "newfile.ml";
}

function open_file(){
  window.input_file.click();
}

function save_file(){
	window.URL = window.webkitURL || window.URL;
	if(window.output_file.href != ""){
		window.URL.revokeObjectURL(window.output_file.href);
	}
	var blob = new Blob([window.editor.getValue()], {type: 'text/plain'});
	window.output_file.href = window.URL.createObjectURL(blob);
	window.output_file.click();
}

function set_progress(value){
  if(value > 1.0)
    value = 1.0;
  var pbar = document.getElementById('progress-bar');
  if(pbar != null) 
    pbar.style.width = Math.round(value*100).toString()+'%';
}

function progress_end(){
  setTimeout(function(){set_progress(0)}, 500);
}

function read_file(file){
  if(file.name.match('.*\\.ml')){
    var reader = new FileReader();

    reader.onload = function(e){
      window.editor.setValue(e.target.result);
	  window.output_file.download = file.name;
      progress_end();
    };

    reader.onprogress = function(e){
      if(e.lengthComputable){
        set_progress(e.loaded/e.total);
      }
    };

    reader.readAsText(file);
  }
}

function handle_file_selection(e){
  var files = e.target.files;

  if(files != null && files.length > 0){
    read_file(files[0]);
  }
}

function setup_controls(){
	window.input_file = document.getElementById('file-input');
	window.input_file.addEventListener('change', handle_file_selection, false);

	window.output_file = document.getElementById('file-output');
	window.output_file.download = "newfile.ml";

	var panes = document.getElementById("panes");
	var top_pane = document.getElementById('top-pane');
	var bottom_pane = document.getElementById('bottom-pane');
    var pane_sep = document.getElementById('panes-separator');
	var sep_h = pane_sep.clientHeight;
	var margins = 35+25+3;

	var limit_top = 100;
    var limit_bottom = 90;

	var ondrag = function(el, pageX, startX, pageY, startY, fix){
		fix.skipY = true;
		fix.skipX = true;

		var height = window.innerHeight-margins;

		/*if (pageY < window.innerHeight * limit_top / 100) {
            pageY = window.innerHeight * limit_top / 100;
            fix.pageY = pageY;
        }
        if (pageX > window.innerWidth * limit_bottom / 100) {
            pageX = window.innerWidth * limit_bottom / 100;
            fix.pageX = pageX;
        }*/

        var cur = pageY-35; 
        if (cur < limit_top){
            cur = limit_top;
        }
        if (cur > height-limit_bottom) {
            cur = height-limit_bottom;
        }

        var bottom = (height-cur-sep_h);
        top_pane.style.height = cur + 'px';
        bottom_pane.style.height = bottom + 'px';

		window.editor.resize();
	}

	pane_sep.drag(ondrag, null, 'vertical');
}

function load_script(url, callback, progress){
	var script = document.createElement('script');
	script.setAttribute("type","text/javascript");
	script.setAttribute("src", url);

  var done = function(){
    //console.log(url);
    //console.log(progress);
    if(callback != null)
      callback();
    set_progress(progress);
  }

	if(callback != null){
		if(script.readyState) {  //IE
			script.onreadystatechange = function() {
				if(script.readyState === "loaded" || script.readyState === "complete"){
					script.onreadystatechange = null;
					done();
				}
			};
		}else{  //Others
			script.onload = done;
		}
	}
	document.getElementsByTagName("head")[0].appendChild(script);
}

function load_scripts(list, onload, total = null){
  if(total == null){
    set_progress(0);
    total = list.length;
  }
  if(list.length > 0){
    var url = list.shift();
    load_script(url, function(){load_scripts(list);}, (total-list.length)/total);
  }else{
    if(onload != null)
      onload();
    set_progress(1.0);
    progress_end();
  }
}

window.onload = function(){
	load_ace();
  setup_controls();  
}

function load_toplevel(){
	console.log("loading toplevel...");
	load_scripts([
      "toplevel/exported-unit.cmis.js",
	    "stdlib.cmis.js",
	    "toplevel/js_of_ocaml.cmis.js",
	    //"toplevel/js_of_ocaml-ppx.as-lib.cmis.js",
	    "toplevel/js_of_ocaml.toplevel.cmis.js",
	    //"toplevel/js_of_ocaml.deriving.cmis.js",
	    "toplevel/js_of_ocaml.tyxml.cmis.js",
	    "toplevel/lwt.cmis.js",
	    "toplevel/react.cmis.js",
	    "toplevel/reactiveData.cmis.js",
	    "toplevel/dynlink.cmis.js",
	    "toplevel/bigarray.cmis.js",
	    "toplevel/toplevel.js"
  ], function(){console.log("done");});
}

load_toplevel();
