val compiler_name : string
val by_id : string -> Dom_html.element Js.t
val by_id_coerce : string -> (Dom_html.element Js.t -> 'a Js.Opt.t) -> 'a
val do_by_id : string -> (Dom_html.element Js.t -> unit) -> unit
val exec' : string -> unit
val setup_toplevel : unit -> unit
val resize :
  container:< scrollHeight : < get : 'a; .. > Js.gen_prop;
              scrollTop : < set : 'a -> unit; .. > Js.gen_prop; .. >
            Js.t ->
  textbox:< scrollHeight : < get : int; .. > Js.gen_prop;
            style : < get : < height : < set : Js.js_string Js.t -> unit;
                                         .. >
                                       Js.gen_prop;
                              .. >
                            Js.t;
                      .. >
                    Js.gen_prop;
            .. >
          Js.t ->
  unit -> unit Lwt.t
val setup_printers : unit -> unit
val setup_examples :
  container:< scrollHeight : < get : 'a; .. > Js.gen_prop;
              scrollTop : < set : 'a -> unit; .. > Js.gen_prop; .. >
            Js.t ->
  textbox:< focus : 'b Js.meth; scrollHeight : < get : int; .. > Js.gen_prop;
            style : < get : < height : < set : Js.js_string Js.t -> unit;
                                         .. >
                                       Js.gen_prop;
                              .. >
                            Js.t;
                      .. >
                    Js.gen_prop;
            value : < set : Js.js_string Js.t -> unit; .. > Js.gen_prop; .. >
          Js.t ->
  unit
val parse_hash : unit -> (string * string) list
val iter_on_sharp :
  f:(Dom_html.element Js.t -> unit) -> Dom.node Js.t -> unit
val setup_js_preview : unit -> unit
val current_position : int ref
val highlight_location : Location.t -> unit
val append :
  (a_class:'a -> 'b -> 'c Tyxml_js.To_dom.elt) ->
  #Dom.node Js.t -> 'a -> 'b -> unit
module History :
  sig
    val data : string array ref
    val idx : int ref
    val get_storage : unit -> Dom_html.storage Js.t
    val setup : unit -> unit
    val push : string -> unit
    val current : string -> unit
    val previous :
      < value : < set : Js.js_string Js.t -> unit; .. > Js.gen_prop; .. >
      Js.t -> unit
    val next :
      < value : < set : Js.js_string Js.t -> unit; .. > Js.gen_prop; .. >
      Js.t -> unit
  end
val run : 'a -> unit
val onload : (Dom_html.window Js.t, 'a) Dom.event_listener -> 'a -> bool Js.t
